scoreboard players set @s mirror 0

# detect mirror direction
execute as @s at @s rotated as @s if entity @s[y_rotation=0] if block ~ ~ ~ minecraft:jungle_fence_gate[facing=west] run scoreboard players set @s mirror 1
execute as @s at @s rotated as @s if entity @s[y_rotation=0] if block ~ ~ ~ minecraft:jungle_fence_gate[facing=east] run scoreboard players set @s mirror 1
execute as @s at @s rotated as @s if entity @s[y_rotation=0] if block ~ ~ ~ minecraft:jungle_fence_gate[facing=north] run scoreboard players set @s mirror -1
execute as @s at @s rotated as @s if entity @s[y_rotation=0] if block ~ ~ ~ minecraft:jungle_fence_gate[facing=south] run scoreboard players set @s mirror -1

execute as @s at @s rotated as @s if entity @s[y_rotation=90] if block ~ ~ ~ minecraft:jungle_fence_gate[facing=west] run scoreboard players set @s mirror -1
execute as @s at @s rotated as @s if entity @s[y_rotation=90] if block ~ ~ ~ minecraft:jungle_fence_gate[facing=east] run scoreboard players set @s mirror -1
execute as @s at @s rotated as @s if entity @s[y_rotation=90] if block ~ ~ ~ minecraft:jungle_fence_gate[facing=north] run scoreboard players set @s mirror 1
execute as @s at @s rotated as @s if entity @s[y_rotation=90] if block ~ ~ ~ minecraft:jungle_fence_gate[facing=south] run scoreboard players set @s mirror 1

execute as @s at @s rotated as @s if entity @s[y_rotation=180] if block ~ ~ ~ minecraft:jungle_fence_gate[facing=west] run scoreboard players set @s mirror 1
execute as @s at @s rotated as @s if entity @s[y_rotation=180] if block ~ ~ ~ minecraft:jungle_fence_gate[facing=east] run scoreboard players set @s mirror 1
execute as @s at @s rotated as @s if entity @s[y_rotation=180] if block ~ ~ ~ minecraft:jungle_fence_gate[facing=north] run scoreboard players set @s mirror -1
execute as @s at @s rotated as @s if entity @s[y_rotation=180] if block ~ ~ ~ minecraft:jungle_fence_gate[facing=south] run scoreboard players set @s mirror -1

execute as @s at @s rotated as @s if entity @s[y_rotation=-90] if block ~ ~ ~ minecraft:jungle_fence_gate[facing=west] run scoreboard players set @s mirror -1
execute as @s at @s rotated as @s if entity @s[y_rotation=-90] if block ~ ~ ~ minecraft:jungle_fence_gate[facing=east] run scoreboard players set @s mirror -1
execute as @s at @s rotated as @s if entity @s[y_rotation=-90] if block ~ ~ ~ minecraft:jungle_fence_gate[facing=north] run scoreboard players set @s mirror 1
execute as @s at @s rotated as @s if entity @s[y_rotation=-90] if block ~ ~ ~ minecraft:jungle_fence_gate[facing=south] run scoreboard players set @s mirror 1

# rotate
execute as @s at @s rotated as @s if score @s mirror matches 1 run tp @s ~ ~ ~ ~90 ~
execute as @s at @s rotated as @s if score @s mirror matches -1 run tp @s ~ ~ ~ ~-90 ~

# trigger blocks
execute as @s at @s if block ~ ~ ~ minecraft:dead_brain_coral run setblock ~ ~ ~ minecraft:dead_tube_coral[waterlogged=false]
execute as @s at @s if block ~ ~ ~ minecraft:dead_tube_coral run setblock ~ ~-2 ~ minecraft:redstone_block
execute as @s at @s if block ~ ~ ~ minecraft:birch_fence_gate run setblock ~ ~-2 ~ minecraft:redstone_block

# particles
execute as @s at @s unless score @s mirror matches 0 if entity @s[y_rotation=0] run particle dust 1 0 0 1 ~ ~.5 ~.25 0 0 .25 1 2 normal
execute as @s at @s unless score @s mirror matches 0 if entity @s[y_rotation=180] run particle dust 1 0 0 1 ~ ~.5 ~-.25 0 0 .25 1 2 normal
execute as @s at @s unless score @s mirror matches 0 if entity @s[y_rotation=90] run particle dust 1 0 0 1 ~-.25 ~.5 ~ .25 0 0 1 2 normal
execute as @s at @s unless score @s mirror matches 0 if entity @s[y_rotation=-90] run particle dust 1 0 0 1 ~ ~-.25 ~ .25 0 0 1 2 normal
execute as @s at @s if score @s mirror matches 0 if entity @s[y_rotation=0] run particle dust 1 0 0 1 ~ ~.5 ~ 0 0 .5 1 2 normal
execute as @s at @s if score @s mirror matches 0 if entity @s[y_rotation=180] run particle dust 1 0 0 1 ~ ~.5 ~ 0 0 .5 1 2 normal
execute as @s at @s if score @s mirror matches 0 if entity @s[y_rotation=90] run particle dust 1 0 0 1 ~ ~.5 ~ .5 0 0 1 2 normal
execute as @s at @s if score @s mirror matches 0 if entity @s[y_rotation=-90] run particle dust 1 0 0 1 ~ ~.5 ~ .5 0 0 1 2 normal

# teleportation
execute as @s at @s rotated as @s run tp @s ^ ^ ^1

# repeat if on a valid block
execute as @s at @s if block ~ ~ ~ minecraft:spruce_fence_gate run function laser:single
execute as @s at @s if block ~ ~ ~ minecraft:birch_fence_gate run function laser:single
execute as @s at @s if block ~ ~ ~ minecraft:jungle_fence_gate run function laser:single
execute as @s at @s if block ~ ~ ~ minecraft:dead_brain_coral run function laser:single
execute as @s at @s if block ~ ~ ~ minecraft:dead_tube_coral run function laser:single
execute as @s at @s if block ~ ~ ~ minecraft:redstone_wire run function laser:single
execute as @s at @s if block ~ ~ ~ minecraft:air run function laser:single