setblock 28 24 -12 minecraft:air
setblock 28 24 -27 minecraft:air
execute if score runs data matches 1 as @e[tag=elevatorroom3] at @s run tp @s ~ 26 ~
execute if score runs data matches 2.. run setblock 28 24 -12 minecraft:redstone_torch
execute if score runs data matches 2.. as @e[tag=elevatorroom3] at @s run tp @s ~ 30 ~
execute if score runs data matches ..2 as @e[tag=elevatorroom4] at @s run tp @s ~ 26 ~
execute if score runs data matches 3.. run setblock 28 24 -27 minecraft:redstone_torch
execute if score runs data matches 3.. as @e[tag=elevatorroom4] at @s run tp @s ~ 30 ~
execute if score runs data matches ..2 run fill 12 29 -16 12 31 -16 spruce_planks
execute if score runs data matches 3.. run clone 12 29 -17 12 31 -17 12 29 -16

kill @e[type=item]

# puzzle boxes

clone -9 13 35 -9 13 35 -16 9 36

clone 11 14 60 11 14 60 11 9 60
clone 2 14 63 2 14 63 2 9 63
clone -2 14 69 -2 14 69 -2 9 69

clone 7 11 94 7 11 94 7 6 94

clone 31 12 91 31 12 91 31 6 91

clone 43 12 53 43 12 53 43 6 53


# key items
gamerule doEntityDrops false
kill @e[type=minecraft:item_frame,tag=key7]
kill @e[type=minecraft:item_frame,tag=key4]
kill @e[type=minecraft:item_frame,tag=key3]
kill @e[type=minecraft:item_frame,tag=key6]
kill @e[type=minecraft:item]
gamerule doEntityDrops true
scoreboard players set key7found data 0
scoreboard players set key4found data 0
scoreboard players set key3found data 0
scoreboard players set key6found data 0
scoreboard players set keysfound data 0

# puzzle start situation

fill 12 9 34 14 11 34 glass
fill 12 9 39 14 11 39 glass
fill 14 8 43 12 8 30 minecraft:smooth_quartz replace barrier
fill 14 8 43 12 8 30 minecraft:smooth_quartz replace air
fill 18 9 37 18 11 36 minecraft:air

fill -12 9 40 -20 9 33 air replace minecraft:jungle_fence_gate
fill -9 9 37 -9 11 36 minecraft:air

fill 14 9 65 8 9 65 air replace minecraft:redstone_wire
setblock 8 9 58 air
fill 13 9 58 15 9 58 air replace minecraft:redstone_wire
fill 1 9 66 0 9 57 air replace minecraft:redstone_wire
fill -6 9 57 -6 9 66 air
fill -8 9 62 -8 9 57 air replace minecraft:redstone_wire
clone -5 14 70 -2 14 72 -5 9 70
fill 1 9 72 11 9 75 air replace minecraft:redstone_wire
fill 18 9 61 18 11 62 minecraft:air

fill 11 6 105 9 6 96 air replace minecraft:redstone_wire
fill 11 6 105 9 6 96 air replace minecraft:jungle_fence_gate
fill -1 6 105 1 6 96 air replace minecraft:redstone_wire
fill -1 6 105 1 6 96 air replace minecraft:jungle_fence_gate
setblock 5 6 104 air

fill 38 6 108 26 6 91 air replace minecraft:redstone_wire
fill 38 6 108 26 6 91 air replace minecraft:jungle_fence_gate
setblock 32 6 96 minecraft:redstone_wire

fill 42 6 53 33 6 67 air replace minecraft:redstone_wire
setblock 35 6 65 minecraft:redstone_wire
fill 48 10 59 34 10 72 air replace minecraft:jungle_fence_gate

# other
execute as @e[type=minecraft:painting] run data merge entity @s {Invulnerable:1b}
scoreboard players set phase data 0
scoreboard players set trappedcorr data 0
scoreboard players set elride data 0
setblock 972 13 -34 barrier
setblock -64 17 -24 minecraft:air
setblock -65 17 -23 minecraft:air
setblock -66 17 -24 minecraft:air
clone -45 21 -66 -45 21 -66 -46 17 -68
setblock -5 16 -22 stone_bricks

# deactivate lasers
tag @e[tag=laserem] remove active

# random items
setblock 25 33 -25 minecraft:redstone_block

# block door
fill -15 10 1112 -15 11 1112 minecraft:black_concrete

# reset tape
kill @e[type=minecraft:item_frame,tag=tape]
scoreboard players set tapein data 0

# reset elevator
kill @e[tag=elevatorbot]
kill @e[tag=elevatorbotblock]
summon minecraft:armor_stand 981 17.253 -49 {NoGravity:1b,Small:1b,Invisible:1b,Tags:["elevatorbot"],Passengers:[{id:"minecraft:falling_block",BlockState:{Name:"minecraft:dead_horn_coral"},Time:1,Tags:["elevatorbotblock"]}],Rotation:[180f,0f]}
kill @e[tag=elevatortop]
summon minecraft:armor_stand 981 17.73 -49 {ArmorItems:[{},{},{},{id:"minecraft:dead_horn_coral_fan",Count:1b}],NoGravity:1b,Invisible:1b,Tags:["elevatortop"],Rotation:[180f,0f]}

# abyss
clone 1010 16 -47 1010 16 -47 1010 12 -47
tag 6cb2d31d-9a26-4c8d-b328-14039d9d3519 remove active
fill 1011 12 -24 1010 12 -16 air
clone 1018 20 -18 1018 20 -18 1018 12 -18
clone 1017 21 -10 1017 21 -10 1017 12 -10
kill @e[tag=creepydude]
summon armor_stand 1006.739 15.6 -45.7 {NoBasePlate:1b,NoGravity:1b,Tags:["creepydude"],ShowArms:1b,ArmorItems:[{id:"leather_boots",Count:1b,tag:{display:{color:0}}},{id:"leather_leggings",Count:1b,tag:{display:{color:0}}},{id:"leather_chestplate",Count:1b,tag:{display:{color:0}}},{id:"wither_skeleton_skull",Count:1b}],HandItems:[{},{}],Pose:{Head:[29f,35f,47f],LeftLeg:[287f,348f,0f],RightLeg:[299f,29f,0f],LeftArm:[338f,317f,0f],RightArm:[324f,59f,0f]}}
clone 1011 22 -46 1013 24 -46 1011 12 -46
clone 1005 24 -42 1008 26 -42 1005 16 -42
data merge entity @e[tag=assembly,limit=1] {HandItems:[{},{}]}
tp @e[tag=assembly] 977 12 -46
tp @e[tag=elevatortop] 981 17.73 -49 180 0
tp @e[tag=elevatorbot] 981 17.253 -49 180 0
clone 979 17 -48 979 18 -48 977 12 -46
setblock 1011 14 -40 minecraft:air

# activate all codes
fill -19 4 0 -19 4 -7 minecraft:lime_wool

# door trigger
setblock -4 16 -22 minecraft:stone_bricks
setblock 29 13 -32 minecraft:stone_bricks
setblock 12 33 -29 minecraft:stone_bricks
setblock 15 33 -29 minecraft:stone_bricks
setblock 18 33 -29 minecraft:stone_bricks
setblock 11 33 -12 minecraft:stone_bricks
setblock 7 33 -6 minecraft:stone_bricks

# elevator stuff
scoreboard players set enterelevator data 0
fill -86 20 149 -84 20 150 black_concrete
fill -88 20 140 -82 25 140 air
fill -88 20 140 -82 20 140 barrier
kill @e[tag=endas]

# close/open doors
clone 11 33 -25 11 34 -24 4 19 -9
clone 11 33 -25 11 34 -24 4 19 -31
execute positioned 4 19 -9 run kill @e[type=item,distance=..2]
execute positioned 4 19 -31 run kill @e[type=item,distance=..2]
setblock 28 15 -32 minecraft:air
setblock 16 29 -19 minecraft:stone_bricks
fill 28 25 -20 28 27 -19 minecraft:air
setblock -12 5 90 minecraft:redstone_wall_torch

# refill chests & item frames
clone 10 33 -28 10 33 -27 -4 20 -27
execute unless entity @e[tag=axe_frame] run summon minecraft:item_frame 12.5 26 -19.5 {Facing:1,Invisible:1b,Tags:["axe_frame"]}
data modify entity @e[tag=axe_frame,limit=1] Item set from entity @e[tag=axe_frame_template,limit=1] Item
data modify entity @e[tag=axe_frame,limit=1] ItemRotation set value 5
data modify entity @e[tag=axe_frame,limit=1] Fixed set value 1b